/*	
 *	clippky.h
 *
 *	P/ECE POKEY(CO12294) Emulator
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Mon Jan 26 20:20:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __CLIP_PKY_H__
#define __CLIP_PKY_H__

/****************************************************************************
 *
 ****************************************************************************/

typedef struct _POKEY POKEY;

/***** Channel *****/
typedef struct _POKEYCHANNEL {
	int period;			/* o͔]TCN */
	int volume;			/* Volume (0`15) */
	int volume_only;		/* VolumeOnly (0:No/1:Yes) */
	int distotion;			/* Distotion (0`7) */
	//
	int output;			/* ݂̏o͒l */
	int progress;			/* TCNisJE^ */
} POKEYCHANNEL;

/***** Linear Feedback Shift Register *****/
typedef struct _POKEYLFSR {
	int output;			/* ݂̏o͒l */
	int progress;			/* TCNisJE^ */
} POKEYLFSR;

/***** POKEY Chip *****/
/*typedef*/ struct _POKEY {
	unsigned char reg[16];		/* WX^lۑ */
	//
	POKEYLFSR lfsr4;		/* 4bit LFSR */
	POKEYLFSR lfsr5;		/* 5bit LFSR */
	POKEYLFSR lfsr17_9;		/* 17or9bit LFSR */
	POKEYCHANNEL channel[4];	/* `l1`4 */
	//
	DDA progress;			/* TCNisDDA */
} /*POKEY*/;

int pokey_process(POKEY* pokey, int cycle);
void pokey_lfsr_process(POKEY* pokey, int cycle);
int pokey_channel_process(POKEY* pokey, POKEYCHANNEL* channel, int cycle);
void pokey_channel_setup_period(POKEY* pokey, int i_channel);

/****************************************************************************
 *	LFSRo̓e[u
 ****************************************************************************/

extern const unsigned char pokey_lfsr_table4[0x2/*output=0xf[bits],padding=1[bits]*/];
extern const unsigned char pokey_lfsr_table5[0x4/*output=0x1f[bits],padding=1[bits]*/];
extern const unsigned char pokey_lfsr_table9[0x40/*output=0x1ff[bits],padding=1[bits]*/];
extern const unsigned char pokey_lfsr_table17[0x4000/*output=0x1ffff[bits],padding=1[bits]*/];

/****************************************************************************
 *	AvP[Vp֐
 ****************************************************************************/

/* POKEYRAZbg܂B
 * [in]
 *	pokey		POKEY\́B
 *	clock		̓NbNB
 * [note]
 *	* AvP[VvÓAȂƂŏɈxÅ֐ĂяoĂB
 *	  ̌́APOKEYZbgsꍇɁAKvɉČĂяoĂB
 */
void pokey_reset(POKEY* pokey, int clock);

/* WX^lǂݍ݂܂B
 * [in]
 *	pokey		POKEY\́B
 *	regno		WX^ԍB
 */
unsigned char pokey_read(POKEY* pokey, int regno);

/* WX^l݂܂B
 * [in]
 *	pokey		POKEY\́B
 *	regno		WX^ԍB
 *	data		WX^lB
 */
void pokey_write(POKEY* pokey, int regno, unsigned char data);

/* o̓TvO[g=SPEAKER_OUTPUT[Hz]ŁAw肳ꂽTṽ~LVOs܂B
 * [in]
 *	pokey		POKEY\́B
 *	wbuff		o̓Tvobt@B
 *	count		o̓TvB
 */
void pokey_mix(POKEY* pokey, short wbuff[/*count*/], int count);

#endif /*__CLIP_PKY_H__*/
