/*	
 *	framsap.c
 *
 *	P/ECE SAP Driver
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Mon Jan 26 06:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "clip.h"

/****************************************************************************
 *	M6502G~[VpO֐
 ****************************************************************************/

#ifdef SAP_IO_READ /* I/O READΉ̂ */
unsigned char
sap_m6502_read(M6502* m6502, unsigned short addr)
{
	SAPDRIVER* sap = (SAPDRIVER*)m6502;
	unsigned char* mem = sap->mem;

	/* Hardware I/O area */
	if(addr >= 0xd000 && addr <= 0xdfff) {
		return sap_m6502_in(m6502, addr);
	}

	return mem[addr];
}
#endif /*SAP_IO_READ*/

void
sap_m6502_write(M6502* m6502, unsigned short addr, unsigned char data)
{
	SAPDRIVER* sap = (SAPDRIVER*)m6502;
	unsigned char* mem = sap->mem;

	/* Hardware I/O area */
	if(addr >= 0xd000 && addr <= 0xdfff) {
		sap_m6502_out(m6502, addr, data);
		return;
	}

	mem[addr] = data;
}

